package com.webClient.dayTwo;

import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.client.RestTemplate;
import org.springframework.web.reactive.function.client.WebClient;

import java.util.HashMap;

public class WebClientController {

  String url = "http://localhost:8081";
  WebClient webClient = WebClient.builder().baseUrl(url).build();

  @GetMapping("/person/{id1}/{id2}/{id3}")
  public String getPerson(@PathVariable int id1, @PathVariable int id2, @PathVariable int id3) {
    getPersonWithTemplate(id1, id2, id3);
    return "Processing with RestTemplate...";
  }

  void getPersonWithTemplate(int id1, int id2, int id3) {
    String uri = "http://localhost:8081/person/{id}";
    RestTemplate restTemplate = new RestTemplate();
  }

  @GetMapping("/people")
  public String getPeople() {
    webClient.get()
            .uri("/people")
            .accept(MediaType.APPLICATION_JSON)
            .retrieve()
            .bodyToFlux(Person.class)
            .subscribe(person -> {
              System.out.println("Peps");
              System.out.println(person);
            });

    return "Peoples";

  }
}
